HashMapperStringToSchemaType (JiBX Java data binding to XML - Version 1.2.3)
Keywords: org.jibx.extras.HashMapperStringToSchemaType class

Overview | Package | Class | Deprecated
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jibx.extras
Class HashMapperStringToSchemaType

    java.lang.Object
      org.jibx.extras.HashMapperStringToSchemaType

All Implemented Interfaces:
  IAliasable, IMarshaller, IUnmarshaller

    public class HashMapperStringToSchemaType

extends java.lang.Object
implements IMarshaller, IUnmarshaller, IAliasable

Custom marshaller/unmarshaller for `java.util.Map` instances. This handles mapping hash maps with string keys and values that match basic schema datatypes to and from XML. The key objects are marshalled as simple text values, using the `toString()` method to convert them to `String` if they are not already of that type. When unmarshalling the keys are always treated as `String` values. The corresponding values can be any of the object types corresponding to basic schema data types, and are marshalled with xsi:type attributes to specify the type of each value. The types currently supported are `Byte`, `Double`, `Float`, `Integer`, `Long`, `java.util.Date` (as xsd:dateTime), `java.sql.Date` (as xsd:date), `java.sql.Time` (as xsd:time), `java.math.BigDecimal` (with no exponent allowed, as xsd:decimal), and `java.math.BigInteger` (as xsd:integer). The xsd:type attribute is checked when unmarshalling values to select the proper deserialization and value type. The name of the top-level element in the XML structure can be configured in the binding definition, but the rest of the names are predefined and set in the code (though the namespace configured for the top-level element will be used with all the names).

The net effect is that the XML structure will always be of the form:

    <map-name size="6" xmlns:xsd="http://www.w3.org/2001/XMLSchema">
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
       <entry key="name" xsi:type="xsd:string">John Smith</entry>
       <entry key="street" xsi:type="xsd:string">12345 Happy Lane</entry>
       <entry key="city" xsi:type="xsd:string">Plunk</entry>
       <entry key="state" xsi:type="xsd:string">WA</entry>
       <entry key="rating" xsi:type="xsd:int">6</entry>
       <entry key="joined" xsi:type="xsd:dateTime">2002-08-06T00:13:31Z</entry>
     </map-name>

where "map-name" is the configured top-level element name, the "size" attribute is the number of pairs in the hash map, and the "entry" elements are the actual entries in the hash map.

For unmarshalling this requires an active namespace declaration with a prefix for the schema namespace. All xsi:type attribute values must use this prefix. If more than one prefix is declared for the schema namespace, the innermost one declared must be used.

Author:
  Dennis M. Sosnoski

Field Summary
`static int` | `BOOLEAN_TYPE`
`static int` | `BYTE_TYPE`
`static int` | `BYTERRAY_TYPE`
`static int` | `DATE_TYPE`
`static int` | `DATETIME_TYPE`
`static int` | `DECIMAL_TYPE`
`static int` | `DOUBLE_TYPE`
`static int` | `FLOAT_TYPE`
`static int` | `INT_TYPE`
`static int` | `INTEGER_TYPE`
`static int` | `LONG_TYPE`
`static int` | `SHORT_TYPE`
`static int` | `STRING_TYPE`
`static int` | `TIME_TYPE`

Constructor Summary
`HashMapperStringToSchemaType()` Default constructor.
`HashMapperStringToSchemaType(java.lang.String uri, int index, java.lang.String name)` Aliased constructor.

Method Summary
`boolean` | `isExtension(java.lang.String mapname)` Check if marshaller represents an extension mapping.
`boolean` | `isPresent(IUnmarshallingContext ctx)` Check if instance present in XML.
`void` | `marshal(java.lang.Object obj, IMarshallingContext ictx)` Marshal instance of handled class.
`java.lang.Object` | `unmarshal(java.lang.Object obj, IUnmarshallingContext ictx)` Unmarshal instance of handled class.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### BOOLEAN_TYPE

    public static final int BOOLEAN_TYPE

See Also:
  Constant Field Values

### BYTE_TYPE

    public static final int BYTE_TYPE

See Also:
  Constant Field Values

### DOUBLE_TYPE

    public static final int DOUBLE_TYPE

See Also:
  Constant Field Values

### FLOAT_TYPE

    public static final int FLOAT_TYPE

See Also:
  Constant Field Values

### INT_TYPE

    public static final int INT_TYPE

See Also:
  Constant Field Values

### LONG_TYPE

    public static final int LONG_TYPE

See Also:
  Constant Field Values

### SHORT_TYPE

    public static final int SHORT_TYPE

See Also:
  Constant Field Values

### DATETIME_TYPE

    public static final int DATETIME_TYPE

See Also:
  Constant Field Values

### DECIMAL_TYPE

    public static final int DECIMAL_TYPE

See Also:
  Constant Field Values

### INTEGER_TYPE

    public static final int INTEGER_TYPE

See Also:
  Constant Field Values

### BYTERRAY_TYPE

    public static final int BYTERRAY_TYPE

See Also:
  Constant Field Values

### STRING_TYPE

    public static final int STRING_TYPE

See Also:
  Constant Field Values

### DATE_TYPE

    public static final int DATE_TYPE

See Also:
  Constant Field Values

### TIME_TYPE

    public static final int TIME_TYPE

See Also:
  Constant Field Values

Constructor Detail

### HashMapperStringToSchemaType

    public HashMapperStringToSchemaType()

  Default constructor. This uses a pre-defined name for the top-level element. It'll be used by JiBX when no name information is supplied by the mapping which references this custom marshaller/unmarshaller.

### HashMapperStringToSchemaType

    public HashMapperStringToSchemaType(java.lang.String uri,
                                        int index,
                                        java.lang.String name)

  Aliased constructor. This takes a name definition for the top-level element. It'll be used by JiBX when a name is supplied by the mapping which references this custom marshaller/unmarshaller.

  Parameters:
    `uri` - namespace URI for the top-level element (also used for all other names within the binding)
    `index` - namespace index corresponding to the defined URI within the marshalling context definitions
    `name` - local name for the top-level element

Method Detail

### isExtension

    public boolean isExtension(java.lang.String mapname)

  Description copied from interface: `IMarshaller`
  Check if marshaller represents an extension mapping. This is used by the framework in generated code to verify compatibility of objects being marshalled using an abstract mapping.

  Specified by:
    `isExtension` in interface `IMarshaller`
  Parameters:
    `mapname` - marshaller mapping name (generally the class name to be handled, or abstract mapping type name)
  Returns:
    `true` if this mapping is an extension of the abstract mapping, `false` if not

### marshal

    public void marshal(java.lang.Object obj,
                        IMarshallingContext ictx)
                 throws JiBXException

  Description copied from interface: `IMarshaller`
  Marshal instance of handled class. This method call is responsible for all handling of the marshalling of an object to XML text. It is called at the point where the start tag for the associated element should be generated.

  Specified by:
    `marshal` in interface `IMarshaller`
  Parameters:
    `obj` - object to be marshalled (may be `null` if property is not optional)
    `ictx` - XML text output context
  Throws:
    `JiBXException` - on error in marshalling process

### isPresent

    public boolean isPresent(IUnmarshallingContext ctx)
                      throws JiBXException

  Description copied from interface: `IUnmarshaller`
  Check if instance present in XML. This method can be called when the unmarshalling context is positioned at or just before the start of the data corresponding to an instance of this mapping. It verifies that the expected data is present.

  Specified by:
    `isPresent` in interface `IUnmarshaller`
  Parameters:
    `ctx` - unmarshalling context
  Returns:
    `true` if expected parse data found, `false` if not
  Throws:
    `JiBXException` - on error in unmarshalling process

### unmarshal

    public java.lang.Object unmarshal(java.lang.Object obj,
                                      IUnmarshallingContext ictx)
                               throws JiBXException

  Description copied from interface: `IUnmarshaller`
  Unmarshal instance of handled class. This method call is responsible for all handling of the unmarshalling of an object from XML text, including creating the instance of the handled class if an instance is not supplied. When it is called the unmarshalling context is always positioned at or just before the start tag corresponding to the start of the class data.

  Specified by:
    `unmarshal` in interface `IUnmarshaller`
  Parameters:
    `obj` - object to be unmarshalled (may be `null`)
    `ictx` - unmarshalling context
  Returns:
    unmarshalled object (may be `null`)
  Throws:
    `JiBXException` - on error in unmarshalling process

Overview | Package | Class | Deprecated
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Project Web Site |